"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoHeal = void 0;
const ElementByClassCreator_1 = require("../ElementCreator/ElementByClassCreator");
const ElementByIdCreator_1 = require("../ElementCreator/ElementByIdCreator");
const SimilarElementCreator_1 = require("../ElementCreator/SimilarElementCreator");
const GetCurrentElementInfo_1 = require("../ElementHealer/GetCurrentElementInfo");
const CalculateConfidenceScore_1 = require("../ElementScore/CalculateConfidenceScore");
const GlobalVariable_1 = require("../GlobalVariable");
const GetHealedElementInfo_1 = require("./GetHealedElementInfo");
class AutoHeal {
    static startHealing(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            yield GetCurrentElementInfo_1.GetCurrentElementInfo.checkIfElementAlreadyHealed(locatorName).then((result) => __awaiter(this, void 0, void 0, function* () {
                if (result == null) {
                    yield GetCurrentElementInfo_1.GetCurrentElementInfo.getElementInfo(locatorName).then(() => __awaiter(this, void 0, void 0, function* () {
                        yield ElementByClassCreator_1.ElementByClassCreator.xpathFromClass();
                        yield ElementByIdCreator_1.ElementByIdCreator.xpathFromId();
                        yield SimilarElementCreator_1.SimilarElementCreator.getSimilarXpath();
                    })).then(() => __awaiter(this, void 0, void 0, function* () {
                        yield CalculateConfidenceScore_1.CalculateConfidenceScore.getScore();
                    })).then(() => __awaiter(this, void 0, void 0, function* () {
                        if (GlobalVariable_1.GlobalVariable.HealedElement != 'NA')
                            yield GetHealedElementInfo_1.GetHealedElementInfo.getElementInfo(GlobalVariable_1.GlobalVariable.HealedElement);
                    }));
                }
            }));
        });
    }
}
exports.AutoHeal = AutoHeal;
