"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetCurrentElementInfo = void 0;
const fs_1 = __importDefault(require("fs"));
const GlobalVariable_1 = require("../GlobalVariable");
const GetHealedElementInfo_1 = require("./GetHealedElementInfo");
class GetCurrentElementInfo {
    static getElementInfo(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            GlobalVariable_1.GlobalVariable.ElementMap.set('className', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['CLASS_NAME']);
            GlobalVariable_1.GlobalVariable.ElementMap.set('tag', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['TAG']);
            GlobalVariable_1.GlobalVariable.ElementMap.set('id', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['ID']);
            // GlobalVariable.ElementMap.set('size',(JSON.parse(elementObj))[locatorName]['SIZE']);
            GlobalVariable_1.GlobalVariable.ElementMap.set('parent', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['PARENT']);
            GlobalVariable_1.GlobalVariable.ElementMap.set('xpath', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['XPATH']);
            GlobalVariable_1.GlobalVariable.ElementMap.set('attribute', (JSON.parse(GlobalVariable_1.GlobalVariable.elementObj))[locatorName]['ATTRIBUTES']);
        });
    }
    static checkIfElementAlreadyHealed(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                try {
                    yield GetHealedElementInfo_1.GetHealedElementInfo.readAutoHealJson().then(rep => {
                        GlobalVariable_1.GlobalVariable.autoHealReport = rep;
                        for (let i = 0; i < GlobalVariable_1.GlobalVariable.autoHealReport.length; i += 1) {
                            if (rep[i]['LocatorName'] == locatorName) {
                                console.log('Element Already healed = ' + rep[i]['Healed Xpath']);
                                GlobalVariable_1.GlobalVariable.HealedElement = rep[i]['Healed Xpath'];
                                resolve(rep[i]['Healed Xpath']);
                            }
                        }
                        resolve(null);
                    });
                }
                catch (error) {
                    reject(error);
                }
            }));
        });
    }
    static readUIElementsJson() {
        return __awaiter(this, void 0, void 0, function* () {
            return fs_1.default.readFileSync("./src/" + process.env.PRODUCT + "/ObjectRepository/UI_Elements.json", 'utf-8');
        });
    }
    static storeInfoInJson(locatorName, retryCount) {
        return __awaiter(this, void 0, void 0, function* () {
            if (retryCount == 0) {
                GlobalVariable_1.GlobalVariable.elementObj = yield this.readUIElementsJson();
                let obj = JSON.parse(GlobalVariable_1.GlobalVariable.elementObj);
                GlobalVariable_1.GlobalVariable.ElementMap.set('autoUpdate', JSON.stringify(obj[locatorName]['AUTO_UPDATE']));
            }
        });
    }
    static isElementUpdated(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let elementObj = yield this.readUIElementsJson();
                GlobalVariable_1.GlobalVariable.ElementMap.set('autoUpdate', (JSON.parse(elementObj))[locatorName]['AUTO_UPDATE']);
            }
            catch (error) {
                console.log('Error while fetching data from UIElements.json file = ' + error);
                GlobalVariable_1.GlobalVariable.ElementMap.set('autoUpdate', 0);
            }
        });
    }
    static updateDetailsInJson(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('--------in details update---------');
            let obj = JSON.parse(GlobalVariable_1.GlobalVariable.elementObj);
            obj[locatorName]['AUTO_UPDATE'] = 1;
            obj[locatorName]['RETRY_COUNT'] = 0;
            obj[locatorName]['PARENT'] = GlobalVariable_1.GlobalVariable.ElementMap.get('parent');
            obj[locatorName]['TAG'] = GlobalVariable_1.GlobalVariable.ElementMap.get('tag');
            obj[locatorName]['ATTRIBUTES'] = GlobalVariable_1.GlobalVariable.ElementMap.get('attribute');
            obj[locatorName]['CLASS_NAME'] = GlobalVariable_1.GlobalVariable.ElementMap.get('className');
            obj[locatorName]['ID'] = GlobalVariable_1.GlobalVariable.ElementMap.get('id');
            obj[locatorName]['XPATH'] = GlobalVariable_1.GlobalVariable.HealedElement;
            fs_1.default.writeFileSync("./src/" + process.env.PRODUCT + "/ObjectRepository/UI_Elements.json", JSON.stringify(obj, null, 2));
        });
    }
}
exports.GetCurrentElementInfo = GetCurrentElementInfo;
