"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetHealedElementInfo = void 0;
const GlobalVariable_1 = require("../GlobalVariable");
const fs_1 = __importDefault(require("fs"));
/* Get attributes and properties of the healed test object from from the DOM*/
const { I } = inject();
class GetHealedElementInfo extends Helper {
    static getElementInfo(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            GlobalVariable_1.GlobalVariable.ElementMap.set('className', yield this.getElementClassName(locator));
            GlobalVariable_1.GlobalVariable.ElementMap.set('tag', yield this.getElementTag(locator));
            GlobalVariable_1.GlobalVariable.ElementMap.set('id', yield this.getElementId(locator));
            GlobalVariable_1.GlobalVariable.ElementMap.set('attribute', yield this.getElementAttributes(locator));
            GlobalVariable_1.GlobalVariable.ElementMap.set('parent', yield this.getElementParent(locator));
            console.log('elem map -- ' + [...GlobalVariable_1.GlobalVariable.ElementMap]);
        });
    }
    static getElementClassName(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = '';
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    console.log('element ref class= ' + JSON.stringify(elementRef));
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve('NA');
                            }
                            value = yield browser.getElementProperty(elementRef[key], 'className');
                            resolve(value);
                        });
                    });
                }
                catch (error) {
                    resolve('NA');
                }
            }));
        });
    }
    static getElementTag(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = '';
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve('NA');
                            }
                            value = yield browser.getElementProperty(elementRef[key], 'tagName');
                            resolve(value);
                        });
                    });
                }
                catch (error) {
                    resolve('NA');
                }
            }));
        });
    }
    static getElementId(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = '';
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve('NA');
                            }
                            value = yield browser.getElementProperty(elementRef[key], 'id');
                            resolve(value);
                        });
                    });
                }
                catch (error) {
                    resolve('NA');
                }
            }));
        });
    }
    static getElementSize(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = '';
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve({});
                            }
                            value = yield elementRef.getSize('width');
                            resolve(value);
                        });
                    });
                }
                catch (error) {
                    resolve({});
                }
            }));
        });
    }
    static getElementParent(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value = '';
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve('NA');
                            }
                            value = yield browser.getElementProperty(elementRef[key], 'parentElement');
                            let parentTag = yield browser.getElementProperty(Object.values(value)[0], 'tagName');
                            resolve(parentTag);
                        });
                    });
                }
                catch (error) {
                    resolve('NA');
                }
            }));
        });
    }
    static getElementAttributes(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            let value;
            let attributeArr = {};
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                try {
                    const browser = yield this.prototype.helpers['WebDriver'].browser;
                    const elementRef = yield browser.findElement('xpath', locator);
                    Object.keys(elementRef)
                        .forEach(function eachKey(key) {
                        return __awaiter(this, void 0, void 0, function* () {
                            if (key == 'error') {
                                console.log('-------Error in element ----');
                                resolve('NA');
                            }
                            value = yield browser.getElementProperty(elementRef[key], 'attributes');
                            for (let j = 0; j < value.length; j += 1) {
                                attributeArr[value[j]['nodeName']] = value[j]['nodeValue'];
                            }
                            resolve(attributeArr);
                        });
                    });
                }
                catch (error) {
                    resolve(attributeArr);
                }
            }));
        });
    }
    static storeElementInfoInElementFile(locator, locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            let obj = {
                "CLASS_NAME": GlobalVariable_1.GlobalVariable.ElementMap.get('className'),
                "TAG": GlobalVariable_1.GlobalVariable.ElementMap.get('tag'),
                "ID": GlobalVariable_1.GlobalVariable.ElementMap.get('id'),
                "SIZE": GlobalVariable_1.GlobalVariable.ElementMap.get('size'),
                "PARENT": GlobalVariable_1.GlobalVariable.ElementMap.get('parent')
            };
        });
    }
    static replaceHealedXpath(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            let k = 0;
            for (let i = 0; i < GlobalVariable_1.GlobalVariable.autoHealReport.length; i += 1) {
                if ((GlobalVariable_1.GlobalVariable.autoHealReport)[i]['LocatorName'] == locatorName) {
                    console.log('Element Alredy healed');
                    k = 1;
                }
            }
            if (k == 0) {
                console.log('**** Step : Replace Healed xpath ****' + GlobalVariable_1.GlobalVariable.HealedElement);
                const allurePlugin = codeceptjs.container.plugins('allure');
                yield allurePlugin.createStep('****AUTOHEALING DONE FOR ' + GlobalVariable_1.GlobalVariable.OriginalXpath + '****  Healed Xpath: ' + GlobalVariable_1.GlobalVariable.HealedElement, () => { });
                yield this.writeToJson(locatorName);
            }
        });
    }
    static objInitialization(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let obj = {};
                obj['LocatorName'] = locatorName;
                obj['Old Xpath'] = GlobalVariable_1.GlobalVariable.OriginalXpath;
                obj['Healed Xpath'] = GlobalVariable_1.GlobalVariable.HealedElement;
                return obj;
            }
            catch (error) {
                console.log(error + 'in object initialization');
            }
        });
    }
    static readAutoHealJson() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                try {
                    resolve(JSON.parse(fs_1.default.readFileSync('./autoHealReport.json', "utf-8")));
                }
                catch (error) {
                    console.log(error + ' in reading json file');
                    reject(error);
                }
            });
        });
    }
    static writeToJson(locatorName) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("started writing to FA json");
            yield Promise.all([GlobalVariable_1.GlobalVariable.autoHealReport, this.objInitialization(locatorName)]).then((allPromises) => {
                try {
                    JSON.parse(JSON.stringify(allPromises[1]));
                    try {
                        allPromises[0].push(allPromises[1]);
                        JSON.parse(JSON.stringify(allPromises[0], null, "\t"));
                        try {
                            fs_1.default.writeFileSync('./autoHealReport.json', JSON.stringify(allPromises[0], null, "\t"));
                        }
                        catch (error) {
                            console.log(error + 'in writing to file');
                        }
                    }
                    catch (error) {
                        console.log('Error in parsing combined promise = ' + error);
                    }
                }
                catch (error) {
                    console.log('Error in parsing promise 1 =  ' + error);
                }
            }).catch(error => {
                console.log(error + 'in fulfilling promise');
            });
        });
    }
}
exports.GetHealedElementInfo = GetHealedElementInfo;
