"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalculateConfidenceScore = void 0;
const GlobalVariable_1 = require("../GlobalVariable");
const GetHealedElementInfo_1 = require("../ElementHealer/GetHealedElementInfo");
var _ = require('lodash');
const { I } = inject();
let score = {
    "class": 20,
    "id": 10,
    "tag": 15,
    "attributes": 25,
    "parent": 20,
    "size": 10
};
let confidenceScoreBar = 50;
class CalculateConfidenceScore {
    static getScore() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.getClassXpathScore(GlobalVariable_1.GlobalVariable.classXpath).then(() => __awaiter(this, void 0, void 0, function* () {
                yield this.getIdXpathScore(GlobalVariable_1.GlobalVariable.idXpath).then(() => __awaiter(this, void 0, void 0, function* () {
                    yield this.getSimilarElementXpathScore(GlobalVariable_1.GlobalVariable.similarElementXpath).then(() => {
                        console.log('score map = ' + [...GlobalVariable_1.GlobalVariable.ElementScore]);
                        const sortElementArray = new Map([...GlobalVariable_1.GlobalVariable.ElementScore].sort((a, b) => b[1] - a[1]));
                        if (([...sortElementArray.values()][0]) >= confidenceScoreBar)
                            GlobalVariable_1.GlobalVariable.HealedElement = [...sortElementArray.keys()][0];
                        else
                            GlobalVariable_1.GlobalVariable.HealedElement = 'NA';
                        console.log('-------selected healed element----------' + GlobalVariable_1.GlobalVariable.HealedElement);
                    });
                }));
            }));
        });
    }
    static getClassXpathScore(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('----------calculation class xpath score------------');
            if (locator != 'NA') {
                yield I.grabNumberOfVisibleElements(locator).then((n) => __awaiter(this, void 0, void 0, function* () {
                    for (let i = 1; i <= n; i += 1) {
                        let score = 0;
                        let newXpathClass = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                        score = score + (yield this.classComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('className'), newXpathClass));
                        let newXpathId = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                        score = score + (yield this.idComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('id'), newXpathId));
                        let newXpathParent = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                        score = score + (yield this.parentComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('parent'), newXpathParent));
                        let newXpathTag = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementTag(locator + '[' + i + ']');
                        score = score + (yield this.tagComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('tag'), newXpathTag));
                        // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']');
                        // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                        let newXpathAttributes = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                        score = score + (yield this.attributeComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('attribute'), newXpathAttributes));
                        GlobalVariable_1.GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                        console.log('class score ---- ' + score);
                        console.log('----------------------------------------------');
                    }
                }));
            }
        });
    }
    static getIdXpathScore(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('----------calculation id xpath score------------');
            if (locator != 'NA') {
                yield I.grabNumberOfVisibleElements(locator).then((n) => __awaiter(this, void 0, void 0, function* () {
                    for (let i = 1; i <= n; i += 1) {
                        let score = 0;
                        let newXpathClass = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                        score = score + (yield this.classComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('className'), newXpathClass));
                        let newXpathId = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                        score = score + (yield this.idComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('id'), newXpathId));
                        let newXpathParent = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                        score = score + (yield this.parentComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('parent'), newXpathParent));
                        let newXpathTag = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementTag(locator + '[' + i + ']');
                        score = score + (yield this.tagComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('tag'), newXpathTag));
                        // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']')
                        // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                        let newXpathAttributes = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                        score = score + (yield this.attributeComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('attribute'), newXpathAttributes));
                        GlobalVariable_1.GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                        console.log('id score ---- ' + score);
                        console.log('----------------------------------------------');
                    }
                }));
            }
        });
    }
    static getSimilarElementXpathScore(locator) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log('----------calculation similar xpath score------------');
            yield I.grabNumberOfVisibleElements(locator).then((n) => __awaiter(this, void 0, void 0, function* () {
                for (let i = 1; i <= n; i += 1) {
                    let score = 0;
                    let newXpathClass = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                    score = score + (yield this.classComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('className'), newXpathClass));
                    let newXpathId = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                    score = score + (yield this.idComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('id'), newXpathId));
                    let newXpathParent = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                    score = score + (yield this.parentComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('parent'), newXpathParent));
                    let newXpathTag = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementTag(locator + '[' + i + ']');
                    score = score + (yield this.tagComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('tag'), newXpathTag));
                    // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']')
                    // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                    let newXpathAttributes = yield GetHealedElementInfo_1.GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                    score = score + (yield this.attributeComparison(GlobalVariable_1.GlobalVariable.ElementMap.get('attribute'), newXpathAttributes));
                    GlobalVariable_1.GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                    console.log('simi score ---- ' + score);
                    console.log('----------------------------------------------');
                }
            }));
        });
    }
    static classComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            if (expected != '' && expected != undefined)
                expected = expected.toUpperCase();
            if (actual != '' && actual != undefined)
                actual = actual.toUpperCase();
            if ((expected == actual) || (actual).includes(expected))
                return score.class;
            else
                return 0;
        });
    }
    static idComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            if (expected != '' && expected != undefined)
                expected = expected.toUpperCase();
            if (actual != '' && actual != undefined)
                actual = actual.toUpperCase();
            if (expected == actual)
                return score.id;
            else
                return 0;
        });
    }
    static tagComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            if (expected != '' && expected != undefined)
                expected = expected.toUpperCase();
            if (actual != '' && actual != undefined)
                actual = actual.toUpperCase();
            if (expected == actual)
                return score.tag;
            else
                return 0;
        });
    }
    static parentComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            if (expected != '' && expected != undefined)
                expected = expected.toUpperCase();
            if (actual != '' && actual != undefined)
                actual = actual.toUpperCase();
            if (expected == actual)
                return score.parent;
            else
                return 0;
        });
    }
    static sizeComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            if (JSON.stringify(expected) === JSON.stringify(actual))
                return score.size;
            else
                return 0;
        });
    }
    static attributeComparison(expected, actual) {
        return __awaiter(this, void 0, void 0, function* () {
            let passed = 0;
            let failed = 0;
            Object.keys(expected).map(key => {
                if (actual.hasOwnProperty(key)) {
                    if (expected[key] == actual[key]) {
                        passed += 1;
                    }
                    else
                        failed += 1;
                }
                else {
                    failed += 1;
                }
            });
            if (failed == 0 && passed == 0)
                return 0;
            else
                return ((score.attributes / (passed + failed) * passed));
        });
    }
}
exports.CalculateConfidenceScore = CalculateConfidenceScore;
