import fs from 'fs';
import { GlobalVariable } from '../GlobalVariable';
import { GetHealedElementInfo } from './GetHealedElementInfo';

export class GetCurrentElementInfo {

    static async getElementInfo(locatorName: string) {
        GlobalVariable.ElementMap.set('className', (JSON.parse(GlobalVariable.elementObj))[locatorName]['CLASS_NAME']);
        GlobalVariable.ElementMap.set('tag', (JSON.parse(GlobalVariable.elementObj))[locatorName]['TAG']);
        GlobalVariable.ElementMap.set('id', (JSON.parse(GlobalVariable.elementObj))[locatorName]['ID']);
        // GlobalVariable.ElementMap.set('size',(JSON.parse(elementObj))[locatorName]['SIZE']);
        GlobalVariable.ElementMap.set('parent', (JSON.parse(GlobalVariable.elementObj))[locatorName]['PARENT']);
        GlobalVariable.ElementMap.set('xpath', (JSON.parse(GlobalVariable.elementObj))[locatorName]['XPATH']);
        GlobalVariable.ElementMap.set('attribute', (JSON.parse(GlobalVariable.elementObj))[locatorName]['ATTRIBUTES']);
    }

    static async checkIfElementAlreadyHealed(locatorName: string): Promise<any> {
        return new Promise(async (resolve, reject) => {
            try {
                await GetHealedElementInfo.readAutoHealJson().then(rep => {
                    GlobalVariable.autoHealReport = rep;
                    for (let i = 0; i < GlobalVariable.autoHealReport.length; i += 1) {
                        if (rep[i]['LocatorName'] == locatorName) {
                            console.log('Element Already healed = ' + rep[i]['Healed Xpath']);
                            GlobalVariable.HealedElement = rep[i]['Healed Xpath'];
                            resolve(rep[i]['Healed Xpath']);
                        }
                    }
                    resolve(null);
                })
            }
            catch (error) {
                reject(error)
            }
        })
    }

    static async readUIElementsJson() {
        return fs.readFileSync("./src/" + process.env.PRODUCT + "/ObjectRepository/UI_Elements.json", 'utf-8');
    }

    static async storeInfoInJson(locatorName: string, retryCount: number) {
        if (retryCount == 0) {
            GlobalVariable.elementObj = await this.readUIElementsJson();
            let obj = JSON.parse(GlobalVariable.elementObj);
            GlobalVariable.ElementMap.set('autoUpdate', JSON.stringify(obj[locatorName]['AUTO_UPDATE']));
        }
    }

    static async isElementUpdated(locatorName: string) {
        try {
            let elementObj: any = await this.readUIElementsJson();
            GlobalVariable.ElementMap.set('autoUpdate', (JSON.parse(elementObj))[locatorName]['AUTO_UPDATE']);
        }
        catch (error) {
            console.log('Error while fetching data from UIElements.json file = ' + error);
            GlobalVariable.ElementMap.set('autoUpdate', 0);
        }
    }

    static async updateDetailsInJson(locatorName: string) {
        console.log('--------in details update---------');
        let obj = JSON.parse(GlobalVariable.elementObj);
        obj[locatorName]['AUTO_UPDATE'] = 1;
        obj[locatorName]['RETRY_COUNT'] = 0;
        obj[locatorName]['PARENT'] = GlobalVariable.ElementMap.get('parent')
        obj[locatorName]['TAG'] = GlobalVariable.ElementMap.get('tag')
        obj[locatorName]['ATTRIBUTES'] = GlobalVariable.ElementMap.get('attribute')
        obj[locatorName]['CLASS_NAME'] = GlobalVariable.ElementMap.get('className')
        obj[locatorName]['ID'] = GlobalVariable.ElementMap.get('id')
        obj[locatorName]['XPATH'] = GlobalVariable.HealedElement
        fs.writeFileSync("./src/" + process.env.PRODUCT + "/ObjectRepository/UI_Elements.json", JSON.stringify(obj, null, 2));
    }

    // static async clearElementMap(){
    //     GlobalVariable.ElementMap.clear();
    //     GlobalVariable.ElementScore.clear();
    // }
}
