import { GlobalVariable } from "../GlobalVariable";
import { GetHealedElementInfo } from "../ElementHealer/GetHealedElementInfo";
var _ = require('lodash');
const { I } = inject();
let score = {
    "class": 20,
    "id": 10,
    "tag": 15,
    "attributes": 25,
    "parent": 20,
    "size": 10
}
let confidenceScoreBar=50;

export class CalculateConfidenceScore {
    static async getScore() {
        await this.getClassXpathScore(GlobalVariable.classXpath).then(async ()=>{
            await this.getIdXpathScore(GlobalVariable.idXpath).then(async ()=>{
                await this.getSimilarElementXpathScore(GlobalVariable.similarElementXpath).then(()=>{
                    console.log('score map = ' + [...GlobalVariable.ElementScore]);
                    const sortElementArray = new Map([...GlobalVariable.ElementScore].sort((a, b) => b[1] - a[1]));
                    if(([...sortElementArray.values()][0])>=confidenceScoreBar)
                    GlobalVariable.HealedElement = [...sortElementArray.keys()][0];
                    else
                    GlobalVariable.HealedElement = 'NA';
                    console.log('-------selected healed element----------'+GlobalVariable.HealedElement);
                })
            })
        })
    }

    static async getClassXpathScore(locator: string) {
        console.log('----------calculation class xpath score------------');
        if(locator!='NA'){
        await I.grabNumberOfVisibleElements(locator).then(async (n: number) => {
            for (let i = 1; i <= n; i += 1) {
                let score: number = 0;
                let newXpathClass = await GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                score = score + await this.classComparison(GlobalVariable.ElementMap.get('className') as string, newXpathClass as string)
                let newXpathId = await GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                score = score + await this.idComparison(GlobalVariable.ElementMap.get('id') as string, newXpathId as string)
                let newXpathParent = await GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                score = score + await this.parentComparison(GlobalVariable.ElementMap.get('parent') as string, newXpathParent as string)
                let newXpathTag = await GetHealedElementInfo.getElementTag(locator + '[' + i + ']')
                score = score + await this.tagComparison(GlobalVariable.ElementMap.get('tag') as string, newXpathTag as string)
                // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']');
                // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                let newXpathAttributes = await GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                score = score + await this.attributeComparison(GlobalVariable.ElementMap.get('attribute'), newXpathAttributes)
                GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                console.log('class score ---- '+score);
                console.log('----------------------------------------------');
            }
        })
    }
    }

    static async getIdXpathScore(locator: string) {
        console.log('----------calculation id xpath score------------');
        if(locator!='NA'){
        await I.grabNumberOfVisibleElements(locator).then(async (n: number) => {
            for (let i = 1; i <= n; i += 1) {
                let score: number = 0;
                let newXpathClass = await GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                score = score + await this.classComparison(GlobalVariable.ElementMap.get('className') as string, newXpathClass as string)
                let newXpathId = await GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                score = score + await this.idComparison(GlobalVariable.ElementMap.get('id') as string, newXpathId as string)
                let newXpathParent = await GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                score = score + await this.parentComparison(GlobalVariable.ElementMap.get('parent') as string, newXpathParent as string)
                let newXpathTag = await GetHealedElementInfo.getElementTag(locator + '[' + i + ']')
                score = score + await this.tagComparison(GlobalVariable.ElementMap.get('tag') as string, newXpathTag as string)
                // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']')
                // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                let newXpathAttributes = await GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                score = score + await this.attributeComparison(GlobalVariable.ElementMap.get('attribute'), newXpathAttributes)
                GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                console.log('id score ---- '+score);
                console.log('----------------------------------------------');
            }
        })
    }
    }

    static async getSimilarElementXpathScore(locator: string) {
        console.log('----------calculation similar xpath score------------');
        await I.grabNumberOfVisibleElements(locator).then(async (n: number) => {
            for (let i = 1; i <= n; i += 1) {
                let score: number = 0;
                let newXpathClass = await GetHealedElementInfo.getElementClassName(locator + '[' + i + ']');
                score = score + await this.classComparison(GlobalVariable.ElementMap.get('className') as string, newXpathClass as string)
                let newXpathId = await GetHealedElementInfo.getElementId(locator + '[' + i + ']');
                score = score + await this.idComparison(GlobalVariable.ElementMap.get('id') as string, newXpathId as string)
                let newXpathParent = await GetHealedElementInfo.getElementParent(locator + '[' + i + ']');
                score = score + await this.parentComparison(GlobalVariable.ElementMap.get('parent') as string, newXpathParent as string)
                let newXpathTag = await GetHealedElementInfo.getElementTag(locator + '[' + i + ']')
                score = score + await this.tagComparison(GlobalVariable.ElementMap.get('tag') as string, newXpathTag as string)
                // let newXpathSize = await GetHealedElementInfo.getElementSize(locator + '[' + i + ']')
                // score = score + await this.sizeComparison(GlobalVariable.ElementMap.get('size'), newXpathSize);
                let newXpathAttributes = await GetHealedElementInfo.getElementAttributes(locator + '[' + i + ']');
                score = score + await this.attributeComparison(GlobalVariable.ElementMap.get('attribute'), newXpathAttributes)
                GlobalVariable.ElementScore.set(locator + '[' + i + ']', score);
                console.log('simi score ---- '+score);
                console.log('----------------------------------------------');
            }
        })
    }

    static async classComparison(expected: string, actual: string): Promise<number> {
        if (expected != '' && expected!=undefined)
        expected = expected.toUpperCase();
    if (actual != '' && actual!=undefined)
        actual = actual.toUpperCase(); 
        if ((expected == actual) || (actual).includes(expected))
            return score.class;
        else
            return 0;
    }

    static async idComparison(expected: string, actual: string) {
            if (expected != '' && expected!=undefined)
                expected = expected.toUpperCase();
            if (actual != '' && actual!=undefined)
                actual = actual.toUpperCase();       
        if (expected == actual)
            return score.id;
        else
            return 0;
    }

    static async tagComparison(expected: string, actual: string) {
        if (expected != '' && expected!=undefined)
        expected = expected.toUpperCase();
    if (actual != '' && actual!=undefined)
        actual = actual.toUpperCase(); 
        
        if (expected == actual)
            return score.tag;
        else
            return 0;
    }

    static async parentComparison(expected: string, actual: string) {
        if (expected != '' && expected!=undefined)
        expected = expected.toUpperCase();
    if (actual != '' && actual!=undefined)
        actual = actual.toUpperCase(); 
        if (expected == actual)
            return score.parent;
        else
            return 0;
    }

    static async sizeComparison(expected: any, actual: any) {
        if (JSON.stringify(expected) === JSON.stringify(actual))
            return score.size;
        else
            return 0;
    }

    static async attributeComparison(expected: any, actual: any) {
        let passed = 0;
        let failed = 0;
        Object.keys(expected).map(key => {
            if (actual.hasOwnProperty(key)) {
                if (expected[key] == actual[key]) {
                    passed += 1;
                }
                else
                    failed += 1;
            }
            else {
                failed += 1;
            }
        })
        if (failed == 0 && passed == 0)
            return 0;
        else
            return ((score.attributes / (passed + failed) * passed));
    }
}
